﻿using Rhino;
using Rhino.Commands;
using Rhino.DocObjects;
using Rhino.Input;
namespace AddVertex
{
    public class AddVertexCommand : Command
    {
        public AddVertexCommand()
        {
            Instance = this;
        }
        public static AddVertexCommand Instance
        {
            get; private set;
        }
        public override string EnglishName => "AddVertexToBrep";
        protected override Result RunCommand(RhinoDoc doc, RunMode mode)
        {
            var rc = RhinoGet.GetOneObject("Brep", false, ObjectType.Brep, out var objRef);
            if (rc != Result.Success || objRef == null) return rc;
            var brep = objRef.Brep();
            if (brep == null || !brep.IsValid) return Result.Failure;
            rc = RhinoGet.GetPoint("Vertex to add", false, out var location);
            if (rc != Result.Success) return rc;
            brep.Vertices.Add(location, RhinoMath.UnsetValue);
            doc.Objects.Replace(objRef, brep);
            doc.Views.Redraw();
            return Result.Success;
        }
    }
}
